#include<math.h>

#include"hash_fn.h"
#include"bnb.h"

int onecount(char c) {
        int count = 0;

        while(c) {
            count += (c & 1);
            count >>= 1;
        }
        return count;
    }

#define STRSIGN_LEN (LSIZE << (1))
unsigned long strsign(char *string) {
                  unsigned long sign = 0;
                  int ones = 0, byte = 0;

                  while(byte < STRSIGN_LEN) {
                      char c = string[byte];
                      if(c) ones += onecount(c);
                      byte++;
                      if(! (byte & 1)) {
                          sign <<= 4;
                          sign |= ones;
                          ones = 0;
                      }
                  }
                  return sign;
             }

#define CHAR_SHIFT_MAX (LBITS - (7))
unsigned long _strsign(char *string) {
               unsigned long sign = 0;

               while(*string) {
                  sign ^= ((unsigned long)(*string)) << (sign % CHAR_SHIFT_MAX);
                  string++;
               }
               return sign;
        }

int hash0(unsigned long key,int size) {
       static int initial;
       int pos;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       pos = ((key + (hashstep * hashes)) % size);
       ++hashes;
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int hash1(unsigned long key,int size) {
       static int initial,pos;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       pos = ((key + (hashstep * pos)) % size);
       ++hashes;
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int hash2(unsigned long key,int size) {
       static int pos,initial,step;

       if(hashes == 0) {
            hashes = 1;
            step = 0;
            return pos = initial = key % size;
       }
       ++hashes;
       step += pos;
       pos = ((key + step) % size);
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int hash3(unsigned long key,int size) {
       static int pos,prev,pprev,step;

       if(hashes == 0) {
            hashes = 1;
            step = 0;
            pprev = prev = -1;
            return pos = key % size;
       }
       step += hashes;
       pprev = prev;
       prev = pos;
       ++hashes;
       pos = ((key + step) % size);
       return ((1 << hashes) <= size) && (pos != pprev) ? pos : (-1);
    }

int hash3(unsigned long key,int size) {
       static int initial,pos;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       ++hashes;
       pos = ((key * (pos + 1)) % size);
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int hash4(unsigned long key,int size) {
       static int pos,initial;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       ++hashes;
       pos = ((key + pos) % size);
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int hash5(unsigned long key,int size) {
       static int initial;
       int pos;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       ++hashes;
       pos = ((key * hashes) % size);
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int  _hashstep0(int size) {
        int step = 1,shift = size >> 1;

        while(shift > 0) {
             if(step*step > size) step -= shift;
             else step += shift;
             shift >>= 1;
        }
        return step;
     }

int _hash0(unsigned long key,int size) {
       static int initial;
       int pos;

       if(hashes == 0) {
            hashes = 1;
            return pos = initial = key % size;
       }
       ++hashes;
       pos = ((pos + 1) * _hashstep) % size;
       return ((1 << hashes) <= size) && (pos != initial) ? pos : (-1);
    }

int mdhash(unsigned long key,int size) {
        return key % size;
    }

int rndhash(unsigned long key,int size) {
        int bits = LBITS,rem = 0 pos = 0;

        while(size > 0) {
            size = (size >> 1) + (size & 1);
            rem = key % bits;
            if(key & (unsigned long)(1 << rem)) pos += size;
            rem++;
            key >>= rem;
            bits -= rem;
        }
        return pos;
    }

int  id_hash(unsigned long key,int size) {
        int pos = 0,interval = size,bit = 1 << (LBITS - 1);

        while(interval > 0) {
            interal = (interval & 1) + (interval >> 1);
            if(key & bit) pos += interval;
            bit >>= 1;
        }
        return pos;
     }

int kd_hash(unsigned long key,int shift,int count) {
                unsigned long div = 1 << shift;
                int pos = 0;

                while(count > 0) {
                    pos += key/div;
                    div >>= 1;
                    count--;
                }
                return pos;
              }

unsigned long kr_hash(unsigned long key) {
                unsigned long pos = key;

                return (key <= keydiv) ? key : keymul * kr_hash(key / keydiv);
              }

unsigned short _hashl2s(unsigned long key) {
                    int diff = LBITS - SBITS;
                    unsigned short pos = (unsigned short)(key >> diff);

                    diff >>= 1;
                    if((pos < allones(SBITS)) && ((key << SBITS) >= (allones(diff) << (diff - 1 + SBITS))))
                        pos++;
                    return pos;
                }

long double dhashratio(int len) {
                return pow(2,((long double)IBITS) / (((long double)(IBITS * len)) - 1));
            }

unsigned _hash(unsigned *key,int len,long double hashratio) {
            long double hash = 0,max = 1;
            int bit;

            for(;(--len) >= 0;) {
               for(bit = 0;bit < IBITS;bit++) {
                  if(test(key[len],bit)) hash = max + (hashratio * hash);
                  max += (hashratio * max);
               }
            }
            return (unsigned)hash;
         }

unsigned _vhash(unsigned *key,int len,long double *hashratio) {
            long double hash = 0,max = 1;
            int bit;

            for(;(--len) >= 0;) {
               for(bit = 0;bit < IBITS;bit++) {
                  if(test(key[len],bit)) hash = max + ((*hashratio) * hash);
                  max += ((*hashratio) * max);
                  hashratio++;
               }
            }
            return (unsigned)hash;
         }

int asc_ctrn(int letter) {
        letter -= '0';
        if(letter >= 49) letter -= 6;
        else
            if(letter >= 10) letter -= 7;

        return letter < 62 ? letter : -1;
    }

int asc_citrn(int letter) {
        letter -= '0';
        if(letter >= 10) letter -= 7;

        return letter < 36 ? letter : -1;
    }

#define POW_36_5 (60466176)
#define POW_62_4 (14776336)
unsigned *packkey(unsigned *key,int len,char *string,int case) {
            int i = 0, j = 0, pow = case ? POW_62_4 : POW_36_5,letter;

            key[i] = 0;
            while(1) {
                  if(*string) {
                     letter = (case) ? ctrn(*string) : citrn(*string);
                     if(letter >= 0) {
                         key[i] += (pow * letter);
                         if(! pow) {
                            pow = case ? POW_62_4 : POW_36_5;
                            i++;
                            if(i >= len) break;
                            key[i] = 0;
                         }
                         else pow /= (case) ? 62 : 36;
                     }
                     string++;
                 }
                 else {
                     i++;
                     if(i >= len) break;
                     key[i] = 0;
                 }
            }
            return key;
        }
